/*
 * conv.c
 *
 * All rights reserved. Copyright (C) 1994,1998 by NARITA Tomio
 */

#include <stdlib.h>

#include <import.h>
#include <file.h>
#include <encode.h>
#include <decode.h>
#include <uty.h>
#include <find.h>
#include <begin.h>
#include <conv.h>

public void Conv( file_t *f, boolean_t showFileName )
{
  int idx, segment, offset;
  boolean_t simple, flagStdin;
  i_str_t *istr;
  line_t line;
  head_t head;

  if( NULL != f->sp )
    flagStdin = TRUE;
  else
    flagStdin = FALSE;

  segment = 0;
  istr = NULL;

  for( f->eof = FALSE ; FALSE == f->eof ; segment++ ){
    if( FALSE == FileSeek( f, segment ) )
      return;

    for( offset = 0 ; offset < PAGE_SIZE && FALSE == f->eof ; offset++ ){
      simple = FileLoadLine( f, &idx );
      if( 0 == idx )
	return;

      if( NULL != istr )
	IstrFree( istr );

      if( TRUE == simple )
	istr = DecodeSimple( load_str, &idx );
      else
	istr = Decode( f->inputCodingSystem, load_str, &idx );

      if( TRUE == grep_mode ){
	line.istr = istr;
	line.heads = 1;
	line.head = &head;
	head.ptr = idx;
	(*find_func)( &line );
	if( head.hit && TRUE == showFileName ){
	  printf( "%s: ", f->fileName );
	}
      }

      if( FALSE == grep_mode || TRUE == head.hit ){
	Encode( istr, 0, idx,
	       f->outputCodingSystem, TRUE,
	       encode_str, &encode_length );

	for( idx = 0 ; idx < encode_length ; idx++ )
	  putchar( 0xff & encode_str[ idx ] );

	putchar( LF );
      }
    }
  }
}
